import 'package:dio/dio.dart';

enum API_STATUS { SUSSCESSED, FAILED }

class BaseDataAPI {
  dynamic object;
  var apiStatus;
  BaseDataAPI({this.object, this.apiStatus});
}

void printLogYellow(String message) {
  print('\x1B[33m$message\x1B[0m');
}

void printLogError(String message) {
  print('\x1B[31m$message\x1B[0m');
}

void printLogSusscess(String message) {
  print('\x1B[32m$message\x1B[0m');
}

class BaseAPI {
  static String API = '';
  final Dio _dio = Dio();
  BaseAPI();

  Future<BaseDataAPI> getData(
    url, {
    dynamic body,
    Map<String, dynamic>? params,
    String method = 'get',
  }) async {
    Response response;
    printLogYellow(
        'API:GET:::::::::::::::::::================--------------->');
    print('url: $API$url');
    print('params: $params');
    print('body: $body');
    try {
      Options options = Options();
      options.method = method;
      response = await _dio.request(API + url,
          data: body, queryParameters: params, options: options);
    } on DioError catch (e) {
      printLogError('Error [GET API]: $e');
      printLogYellow(
          'END API GET<---------------================:::::::::::::::');

      return BaseDataAPI(object: [], apiStatus: API_STATUS.FAILED);
    }
    if (response.data is DioError) {
      printLogError('Error [GET API]: ${response.data}');
      printLogYellow(
          'END API GET<---------------================:::::::::::::::');

      return BaseDataAPI(object: [], apiStatus: API_STATUS.FAILED);
    }
    printLogSusscess('Success [GET API]: ${response.data}');
    printLogYellow(
        'END API GET<---------------================:::::::::::::::');
    return BaseDataAPI(object: response.data, apiStatus: API_STATUS.SUSSCESSED);
  }

  Future<BaseDataAPI> postData(
    url, {
    dynamic body,
    Map<String, dynamic>? params,
    String method = 'post',
  }) async {
    Response response;
    printLogYellow(
        'API:POST:::::::::::::::::::================--------------->');
    print('url: $API$url');
    print('params: $params');
    print('body: $body');
    try {
      Options options = Options();
      options.method = method;
      response = await _dio.request(API + url,
          data: body, queryParameters: params, options: options);
    } on DioError catch (e) {
      printLogError('Error [POST API]: $e');
      printLogYellow(
          'END API POST<---------------================:::::::::::::::');
      return BaseDataAPI(object: [], apiStatus: API_STATUS.FAILED);
    }
    if (response.data is DioError) {
      printLogError('Error [POST API]: ${response.data}');
      printLogYellow(
          'END API POST<---------------================:::::::::::::::');
      return BaseDataAPI(object: [], apiStatus: API_STATUS.FAILED);
    }
    printLogSusscess('Success [POST API]: ${response.data}');
    printLogYellow(
        'END API POST<---------------================:::::::::::::::');
    return BaseDataAPI(object: response.data, apiStatus: API_STATUS.SUSSCESSED);
  }
}
